%%%%% Demo 2, projection sparsity %%%%%

%% Data set

clear;
clc;
load demo2;

figure(1001)
clf
hold on

set(gca,'FontName','Helvetica')
set(gca,'FontSize',12)
plot(X(Y==1,1),X(Y==1,2),'ro','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','r');
plot(X(Y==3,1),X(Y==3,2),'bs','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','b');
plot(X(YY==1,1),X(YY==1,2),'g+','MarkerSize',10);
plot(X(YY==3,1),X(YY==3,2),'mx','MarkerSize',10);
plot(X(Y==1,1),X(Y==1,2),'ro','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','r');
plot(X(Y==3,1),X(Y==3,2),'bs','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','b');
legend('Labeled A','Labeled B','Test data','Test data',3);
axis equal;
set(gca,'xtick',[]);
set(gca,'ytick',[]);

hold off
set(gcf,'PaperUnits','centimeters');
set(gcf,'PaperPosition',[0 0 12 12]);
print -depsc Multimodal_Data

%% Euclidean

load demo2;

N = size(X,1);
YY = zeros(N,1);
for i=1:N
	if(Y(i)==0)
        YY(i)=oneNN(X(i,:),X,Y,eye(2));
	end
end
YY=YY-Y;

figure(1002)
clf
hold on

set(gca,'FontName','Helvetica')
set(gca,'FontSize',12)
plot(X(YY==1,1),X(YY==1,2),'r+','MarkerSize',10);
plot(X(YY==3,1),X(YY==3,2),'bx','MarkerSize',10);
plot(X(Y==1,1),X(Y==1,2),'ro','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','r');
plot(X(Y==3,1),X(Y==3,2),'bs','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','b');
legend('Predicted A','Predicted B',4);
axis equal;
set(gca,'xtick',[]);
set(gca,'ytick',[]);

hold off
set(gcf,'PaperUnits','centimeters');
set(gcf,'PaperPosition',[0 0 12 12]);
print -depsc Multimodal_EUC

%% Maxent, projection

clear;
clc;
load demo2;

N = size(X,1);
[S D] = constructSD(Y);
A = solver_GP(1, 0, 0, X, S, D);

P = getProjection(A, 2);
X = X*P';
X = [X(:,2) X(:,1)];

figure(1003)
clf
hold on

set(gca,'FontName','Helvetica')
set(gca,'FontSize',12)
plot(X(Y==1,1),X(Y==1,2),'ro','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','r');
plot(X(Y==3,1),X(Y==3,2),'bs','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','b');
plot(X(YY==1,1),X(YY==1,2),'g+','MarkerSize',10);
plot(X(YY==3,1),X(YY==3,2),'mx','MarkerSize',10);
plot(X(Y==1,1),X(Y==1,2),'ro','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','r');
plot(X(Y==3,1),X(Y==3,2),'bs','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','b');
axis equal;
set(gca,'xtick',[]);
set(gca,'ytick',[]);

hold off
set(gcf,'PaperUnits','centimeters');
set(gcf,'PaperPosition',[0 0 12 12]);
print -depsc Multimodal_MaxentP

%% Maxent, classification

load demo2;

YY = zeros(N,1);
for i=1:N
	if(Y(i)==0)
        YY(i)=oneNN(X(i,:),X,Y,A);
	end
end
YY=YY-Y;

figure(1004)
clf
hold on

set(gca,'FontName','Helvetica')
set(gca,'FontSize',12)
plot(X(Y==1,1),X(Y==1,2),'ro','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','r');
plot(X(Y==3,1),X(Y==3,2),'bs','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','b');
plot(X(YY==1,1),X(YY==1,2),'r+','MarkerSize',10);
plot(X(YY==3,1),X(YY==3,2),'bx','MarkerSize',10);
plot(X(Y==1,1),X(Y==1,2),'ro','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','r');
plot(X(Y==3,1),X(Y==3,2),'bs','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','b');
axis equal;
set(gca,'xtick',[]);
set(gca,'ytick',[]);

hold off
set(gcf,'PaperUnits','centimeters');
set(gcf,'PaperPosition',[0 0 12 12]);
print -depsc Multimodal_MaxentC

%% SERAPH, projection

clear;
clc;
load demo2;

N = size(X,1);
[S D] = constructSD(Y);
A = solver_GP(1, 0, 100, X, S, D);

P = getProjection(A, 2);
X = X*P';

figure(1005)
clf
hold on

set(gca,'FontName','Helvetica')
set(gca,'FontSize',12)
plot(X(Y==1,1),X(Y==1,2),'ro','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','r');
plot(X(Y==3,1),X(Y==3,2),'bs','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','b');
plot(X(YY==1,1),X(YY==1,2),'g+','MarkerSize',10);
plot(X(YY==3,1),X(YY==3,2),'mx','MarkerSize',10);
plot(X(Y==1,1),X(Y==1,2),'ro','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','r');
plot(X(Y==3,1),X(Y==3,2),'bs','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','b');
axis equal;
set(gca,'xtick',[]);
set(gca,'ytick',[]);

hold off
set(gcf,'PaperUnits','centimeters');
set(gcf,'PaperPosition',[0 0 12 12]);
print -depsc Multimodal_SeraphP

%% SERAPH, classification

load demo2;

YY = zeros(N,1);
for i=1:N
	if(Y(i)==0)
        YY(i)=oneNN(X(i,:),X,Y,A);
	end
end
YY=YY-Y;

figure(1006)
clf
hold on

set(gca,'FontName','Helvetica')
set(gca,'FontSize',12)
plot(X(Y==1,1),X(Y==1,2),'ro','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','r');
plot(X(Y==3,1),X(Y==3,2),'bs','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','b');
plot(X(YY==1,1),X(YY==1,2),'r+','MarkerSize',10);
plot(X(YY==3,1),X(YY==3,2),'bx','MarkerSize',10);
plot(X(Y==1,1),X(Y==1,2),'ro','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','r');
plot(X(Y==3,1),X(Y==3,2),'bs','MarkerSize',10,'LineWidth',3,'MarkerFaceColor','b');
axis equal;
set(gca,'xtick',[]);
set(gca,'ytick',[]);

hold off
set(gcf,'PaperUnits','centimeters');
set(gcf,'PaperPosition',[0 0 12 12]);
print -depsc Multimodal_SeraphC
