function P = getProjection(A, d)
% get the d-dimensional projection matrix P induced by A

A = (A+A')/2;
[V D] = eig(A);
[ds,di] = sort(diag(D),'descend');
B = V(:,di(1:d));
B = B.*repmat(sign(sum(B)),size(A,1),1);
P = B.*repmat(real(sqrt(ds(1:d)))',size(A,1),1);
P = P';